' *********************************************************
' *-------------------------------------------------------*
' *- mignon game kit                                     -*
' *-                                                     -*
' *- Olaf Val 2003                                       -*
' *- mit freundlicher Untersttzung von Martin Nawrath   -*
' *-                                                     -*
' *- www.olafval.de/mignon                               -*
' *- (www.khm.de/~nawrath)                               -*
' *-------------------------------------------------------*
' *********************************************************


' Pony Prog Settings:

'Security and Configuration Bits

'  internal RC oscillator  8 Mhz
' (x)  BOOTSZ1
' ( )  BOOTSZ0
' (x)  BOOTRST
' (x)  SUTO
' (x)  Cksel3        Cksel 0..3 = 0100 = 8MHz
' ( )  Cksel2
' (x)  Cksel1
' (x)  Cksel0
' ( )  SUT1
' ( )  COPT

' Configurationen =============================================================
Dim F_s As Bit
Dim F_int As Bit
Dim Tics As Word
Dim Mx(5) As Byte
Dim Mxa(5) As Byte
Dim Mrow As Byte At &H100
Dim Mcol As Byte At &H101
Dim Midx As Byte At &H102
Config Timer0 = Timer , Prescale = 256
$crystal = 8000000
'Baud = 19200
' oscillator calibration byte
Osccal = 158                                      ' Internen Oszillator auf 8MHz ziehen
On Timer0 Tm0isr
Enable Interrupts
Enable Timer0


'Dot-Matrix-LED Prots (5x7):
Config Pind.5 = Output                            ' R7
Config Pinb.2 = Output                            ' R6
Config Pinb.7 = Output                            ' R5
Config Pinb.1 = Output                            ' R4
Config Pinc.4 = Output                            ' R3
Config Pinc.0 = Output                            ' R2
Config Pinc.3 = Output                            ' R1

Config Pind.6 = Output                            ' C1
Config Pinc.1 = Output                            ' C2
Config Pinb.0 = Output                            ' C3
Config Pind.7 = Output                            ' C4
Config Pinc.2 = Output                            ' C5

Config Pinb.4 = Output                            ' Lautsprecher

'Taster:
Config Pind.1 = Input                             'links
Config Pind.0 = Input                             'rechts
Set Portd.0
Set Portd.1
Config Pind.2 = Input                             'oben
Config Pind.3 = Input                             'unten
Set Portd.2
Set Portd.3
Config Pinb.3 = Input                             'Funktion A

Config Pind.4 = Output                            'motor / reed relais
'Config Pinc.5 = Input                             'Funktion B (A/D)
Set Portb.3
Set Portc.5

Declare Sub Geschaft
' Configurationen Ende ========================================================

Print ""
Print ""
Print "Mignon Game Kit"
Print " *** Start ***"
Print ""

'Intro +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   Mx(1) = 0                                      'alle lschen
   Mx(2) = 0
   Mx(3) = 0
   Mx(4) = 0
   Mx(5) = 0
'(
Wait 1                                            'watre 1 sec
Mx(1) = &B0001000                                 'Reihe 1 Mitte
Wait 1
Mx(1) = &B0000000                                 'lsche Reihe 1
Mx(2) = &B0001000
Wait 1
')
Mx(2) = &B0000000
Mx(3) = &B0001000
Wait 1
Mx(3) = &B0000000
Mx(4) = &B0001000
Wait 1

Sound Pinb.4 , 1000 , 100                         'Sound Lnge, Tonhhe
Sound Pinb.4 , 5000 , 80
Wait 2
Mx(4) = &B0000000
'Intro Ende ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'Game Variablen:::
Dim Tick As Word
Dim Press1 As Bit
Dim Press2 As Bit
Dim Press3 As Bit
Dim Press4 As Bit
Dim Press5 As Bit
Dim Press6 As Bit
Dim Printf As Bit
Dim Bb1 As Byte
Dim R As Byte
Dim L As Byte
Dim X As Byte
Dim Y As Byte


Dim W As Word
Dim W35 As Word

Dim P35 As Word

Dim Tick8 As Word


Dim Led As Word
 Dim led1 As Word

Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc


'Warte Schleife ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Do
 'get AD and print to ComPort -----------------------------
  If Printf = 0 Then

      W = Getadc(5)
      W = W - 23
      W35 = W / 80

      'Print "Sensor: " ; W ; " zu 35: " ; W35
      Print W
      Printf = 1

  End If




 '35 Punkte Sensor Volumebar-------------------
   Tick = Tick + 1
  If Tick > 500 Then                              '1000 Takt(
   Tick = 0
   Printf = 0

  'LED ------------------------------------
    Led = Led + 1
    Led1 = W35 * 3
   If Led > Led1 Then
   Led = 0
      Toggle Portd.4
   End If

   Mxa(1) = 0                                     'alle lschen
   Mxa(2) = 0
   Mxa(3) = 0
   Mxa(4) = 0
   Mxa(5) = 0

 '*(
    X = 6
    Y = 0

    For P35 = 1 To 16
       Y = Y + 1
       If Y > 5 Then
          X = X + 1
          Y = 0
       End If
       If P35 <= W35 Then
           Gosub Punktesetzen                     'Punkte mit x(1-7) und y(1-5) setzen
       End If
    Next
   '35 Punkte Sensor Volumebar-------------------
'*)

    Gosub Punktezeigen

  End If                                          '1000 Takt)
'Navigation ende -----------------------

If Pind.2 = 0 Then                                'Tasten abfrage

   ' sound (Sensor Sound) ----------------------
 Tick8 = Tick8 + 1
 If Tick8 > W35 Then
    Tick8 = 0
    Toggle Portb.4
 End If
End If

Loop
'Warte Schleife Ende +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Punktesetzen:
    Bb1 = &B10000000
    R = 8 - X
    For L = 1 To R
     Rotate Bb1 , Left , 1
    Next
    Mxa(y) = Mxa(y) Or Bb1
Return

Punktezeigen:
    For L = 1 To 5
        Mx(l) = Mxa(l)
    Next
Return


' Maschinensprache ************************************************************
' Treiber fr die LED-Dot-Matrix **********************************************
Wait_us:
Wait_us_50_1:
      nop
      nop
      dec      r18
      brne     Wait_us_50_1
      ret
$end Asm
' Timer0 Interrupt Service Routine  2ms
Tm0isr:                                           ' Prescaler 8MHz/256 / 63 8 MHz
Set F_int                                         ' Interrupt Flag
Timer0 = 193                                      ' 256-63= 193 = 2 ms
Incr Tics
$asm
   cbi      Portd,5                               ' Alle Sieben Row Leitungen auf Null setzen
   cbi      Portb,2
   cbi      Portb,7
   cbi      Portb,1
   cbi      Portc,4
   cbi      Portc,0
   cbi      Portc,3
   cbi      Portd,6                               ' Alle 5 Column Leitungen auf Null setzen
   cbi      Portc,1
   cbi      Portb,0
   cbi      Portd,7
   cbi      Portc,2
$end Asm
 If Mcol = 32 Then
      Mcol = 1
      Midx = 0
   End If
   Incr Midx
   If Mcol = 0 Then Mcol = 1
   Shift Mcol , Left , 1
$asm
   lds      r16,{mcol}                            ' Transistoren an Ports D6,C1,B0,D7,C2
Cc1:
   sbrs     r16,1
   rjmp     cc2
   sbi      portd,6
Cc2:
   sbrs     r16,2
   rjmp     cc3
   sbi      portc,1
Cc3:
   sbrs     r16,3
   rjmp     cc4
   sbi      portb,0
Cc4:
   sbrs     r16,4
   rjmp     cc5
   sbi      portd,7
Cc5:
   sbrs     r16,5
   rjmp     ccx
   sbi      portc,2
Ccx:
$end Asm
   Mrow = Mx(midx)
$asm
   lds      r16,{Mrow}                            ' Sieben Row-Pins einschalten gemaess Bitmuster
Rr1:
   sbrs     r16,0                                 ' in Variable Mrow
   rjmp     rr2
   sbi      portd,5
Rr2:
   sbrs     r16,1
   rjmp     rr3
   sbi      portb,2
Rr3:
   sbrs     r16,2
   rjmp     rr4
   sbi      portb,7
Rr4:
   sbrs     r16,3
   rjmp     rr5
   sbi      portb,1
Rr5:
   sbrs     r16,4
   rjmp     rr6
   sbi      portc,4
Rr6:
   sbrs     r16,5
   rjmp     rr7
   sbi      portc,0
Rr7:
   sbrs     r16,6
   rjmp     rrx
   sbi      portc,3
Rrx:
$end Asm
Return
' Maschinensprache Ende ********************************************************
' Treiber fr die LED-Dot-Matrix Ende ******************************************